'
' Hit F10 to run - works on DE0-Nano and DE2-115
'
' 640x480 24bbp VGA Demo with SDRAM driver - runs for 23 seconds before animation appears on VGA output
'
'
CON

  pb = 31	'pushbutton to pause animation: 26 for DE0-Nano, 31 for DE2-115

  s = 43	'scales DAC output (s = 0..128)

DAT		orgh	$E00
		org

		clkset	#$FF			'set 80MHz

		call	#sdram_init		'initialize SDRAM

		setsera	#256+90,#80		'initialize sera for 8T,1Mpbs
                                                'rjo:
                                                ' SETSERA D/#,S/#   - Set SERA configuration to %KKKK_NNNN_MMMM_R_T_DD_CCCCCCC_BB_AAAAAAA
                                                ' #256+90  = %10_1011010 = BB_AAAAAAAA, where BB is the transmit mode %10= 8-bit data,  true    TX polarity (STOP=H, START=L)
                                                'and AAAAAAA is the seven bit transmit pin designation,_1011010=90.
                                                'S=80 clocks, 1M periods per second=clkfreq/80

'
		clrp	#90

		wait	orange			'wait a long time for PC to change baud
                                                 'rjo: what's a long time? turns out to be exactly 4.777703033268 seconds....orange = clocks=$FF8000=16_744_448
                                                 'wait "period" = "D"/clkfreq=orange/80_000_000
'
'
'************************
'*			*
'*	Graphics	*
'*			*
'************************
'
'
' Draw screen left-to-right/top-to-bottom
'
:pixel		mov	xx,xpos			'compute complex arctan of coordinates
		sub	xx,#640/2
		mov	yy,ypos
		sub	yy,#480/2
		qarctan	xx,yy
		getqx	xx
		getqz	zz

		shl	xx,#23			'convert length to sinusoid
		qsincos	xx,#$28
		getqx	yy
		subr	yy,#$80

		shl	yy,#24			'swirl colors
		add	zz,yy

		sub	zz,hswirl		'animate

		call	#chroma			'make chroma from angle
		call	#chroma
		call	#chroma

		mul32	fswirl,pscr		'make balls
		getmull	xx
		not	xx
		shr	xx,#2
		setqz	xx
		mov	xx,xpos
		sub	xx,#640/2
		mov	yy,ypos
		sub	yy,#480/2
		qrotate	xx,yy
		getqx	xx
		getqy	yy
		and	xx,#$FF
		and	yy,#$FF
		sub	xx,#$80
		sub	yy,#$80
		qarctan	xx,yy
		getqx	xx
		mul	xx,#19
		shr	xx,#4
		subr	xx,#255-25	wc
	if_nc	add	xx,#25
		stbytes	xx,xx

		getlfsr	yy			'add hammertone finish
		stbytes	z,#$1F
		mulpix	yy,z
		stbytes	z,#$E0
		addpix	yy,z
		mulpix	xx,yy			'(comment out this line for smooth finish)
		mulpix	pix,xx

		and	xx,#$FF			'add highlights
		mul	xx,xx
		shr	xx,#8
		mul	xx,xx
		shr	xx,#8
		mul	xx,xx
		setbyte	xx,#$FF,#0
		swbytes	xx,#%%1000
		blnpix	pix,xx			'(comment out this line for no highlights)

		shl	zz,#1			'make background
		qsincos	zz,#$66
		getqx	xx
		add	xx,#24
		stbytes	xx,xx
		mulpix	xx,orange
	if_c	mov	pix,xx

		call	#plot			'plot pixel

	if_nc	jmp	#:pixel			'if screen not full, loop for next pixel

		add	hswirl,fswirl		'update animation term for next screen
		djnz	pscr,#:pixel		'if more screens, loop for next screen

		call	#plot			'call plot to write last group of pixels to SDRAM

		jmp	#vga			'start up vga driver


hswirl		long	0
fswirl		long	($7FFFFFFF/27)*2
orange		long	$FF8000
'
'
' Get chroma from 32-bit angle
'
chroma		add	zz,h55555555
		qsincos	zz,#$28

chroma_ret	retd

		getqx	z
		add	z,#$80
		rolbyte	pix,z


h55555555	long	$55555555		'1/3 circle
'
'
' Plot next pixel, C=1 if end of screen
'
plot

		ror	pix,#16			'output R
		serouta	pix
		rol	pix,#8			'output G
		serouta	pix
		rol	pix,#8			'output B
		serouta	pix

		wraux	pix,spb++		'write pixel to aux
		chkspb			wc	'128th pixel?
	if_nc	jmp	#plot_ret

		mov	cmd,#8+6		'write 128 pixels to SDRAM
		mov	adr,pptr
		setspb	#0
		call	#sdram

		setspb	#0			'reset spb
		add	pptr,p200		'update SDRAM address

plot_ret	retd
		incmod	xpos,xlim	wc	'increment position
	if_c	incmod	ypos,ylim	wc
		nop
'
'
' Variables
'
pscr		long	27

auxp		long	0
pptr		long	0
p200		long	$200

pix		long	0
z		long	0

xx		long	0
yy		long	0
zz		long	0

xlim		long	640-1
ylim		long	480-1

xpos		long	0
ypos		long	0


'*******************************
'*  VGA 640 x 480 x 8:8:8 RGB  *
'*******************************

vga		setctra	#%00111			'set ctra for PLL*8
                setfrqa	frqa_			'set frqa

		setvid	#%0100001		'set vid for vga output, negative hsync
		setvidy	vidy_			'set yiq coefficients
		setvidi	vidi_
		setvidq	vidq_

		cfgdacs	#%11_11_11_11		'set dacs to video mode
'
'
' Field loop
'
field		mov	x,#33			'top blanks
		call	#blank

                mov     x,#480			'set visible lines

line	        call	#sync			'do horizontal sync

		mov	y,#5			'display 640 pixels
:loop		mov	cmd,#6			'ready SDRAM read command
		mov	adr,pix_ptr
:spb		setspb	#$00
		waitvid	mode,#0			'issue VID command
		call	#sdram			'fill AUX with 128 pixels from SDRAM
		add	pix_ptr,p200		'update pixel pointer
		notb	:spb,#16		'toggle AUX offset in setspb
		notb	mode,#31		'toggle AUX offset in VID command
		djnz	y,#:loop		'loop until 5 sets of 128 pixels (640 total)

	        djnz    x,#line           	'another line?

                mov     x,#10			'bottom blanks
		call	#blank

		clrp	#0			'do vertical sync
		mov	x,#2
		call	#blank
		setp	#0

		getp	#pb		wc	'repeat frame if pushbutton pressed
	if_c	decmod	tctr,#1		wc	'show each frame twice
	if_nc	sub	pix_ptr,screen_size
	if_nc	jmp	#field

		incmod	sctr,#26	wc	'check if 27th frame
	if_c	mov	pix_ptr,#0		'if so, reset SDRAM pixel ptr
                jmp     #field                  'field loop
'
'
' Blank lines
'
blank		call	#sync			'blank lines
		waitvid	#640,#0
		djnz	x,#blank
blank_ret	ret
'
'
' Horizontal sync
'
sync						'horizontal sync
sync_ret	retd
		waitvid	#16,#0
		waitvid	#96,#1
		waitvid	#48,#0
'
'
' Initialized data
'
frqa_		long	$0A11EB84		'25.175MHz @80MHz clock rate

vidy_		long	$00_01_00_00 * s	'red gain
vidi_		long	$00_00_01_00 * s	'green gain
vidq_		long	$00_00_00_01 * s	'blue gain

		'	color base	mode		clocks/pixel	clocks/waitvid
mode		long	$00 << 24 +	$F << 20 +	1 << 13 +	128
x		long	0
y		long	0
tctr		long	0
sctr		long	0
pix_ptr		long	0
screen_size	long	(640*480)*4


'********************************
'*				*
'*	    Callable		*
'*  Propeller II SDRAM Driver	*
'*     for 16M x 16 devices	*
'*	  (FPGA version)	*
'*				*
'*  Version 0.1			*
'*  11 November 2013		*
'*  by Chip Gracey		*
'*				*
'********************************

{
SDRAM connections:

	P85 = cke (held high)		Port C
	P84 = cs
	P83 = ras
	P82 = cas
	P81 = we
	P80 = udqm (not used)
	P79 = ldqm (not used)
   P78..P77 = ba[1..0]
   P76..P64 = a[12..0]

   P63..P48 = dq[15..0]			Port B


  Note:	All pin directions have a 2-clock delay
	All pin outputs going to SDRAM have a 3-clock delay, since they are registered at the pin
	All pin inputs coming from SDRAM have a 2-clock delay, since they are registered at the pin


Commands (pairs of longs):

name		quads	bytes	cmd	adr
------------------------------------------------------------------------------------------------------------------------
rw_1024		64	1024	%W111	%xxxx_xxxA_AAAA_AAAA_AAAA_AA00_0000_0000
rw_512		32	 512	%W110	%xxxx_xxxA_AAAA_AAAA_AAAA_AAA0_0000_0000
rw_256		16	 256	%W101	%xxxx_xxxA_AAAA_AAAA_AAAA_AAAA_0000_0000
rw_128		 8	 128	%W100	%xxxx_xxxA_AAAA_AAAA_AAAA_AAAA_A000_0000
rw_64		 4	  64	%W011	%xxxx_xxxA_AAAA_AAAA_AAAA_AAAA_AA00_0000
rw_32		 2	  32	%W010	%xxxx_xxxA_AAAA_AAAA_AAAA_AAAA_AAA0_0000
rw_16		 1	  16	%W001	%xxxx_xxxA_AAAA_AAAA_AAAA_AAAA_AAAA_0000
nop		 0	   0	%x000	%xxxx_xxxx_xxxx_xxxx_xxxx_xxxx_xxxx_xxxx
}
'
'
' Initialize SDRAM				clocks
'						------
sdram_init	reps	#16000,#1		'1		repeat nop instruction for 200us @80MHz
		mov	outc,h003FFFFF		'1		cke and cs high
		mov	dirc,h003FFFFF		'16000		set SDRAM signals to outputs (100us)

		mov	outc,h00240400		'1		issue 'precharge all' command
		setb	outc,#20		'1		deselect
		nop				'1		satisy Trp

		mov	outc,h00200037		'1		issue 'set mode' command
		reps	#8,#3			'1		ready to issue 8 'auto refresh' commands
		setb	outc,#20		'1		deselect, satisfy Tmrd

		mov	outc,h00226000		'1		issue 'auto refresh' command
		setb	outc,#20		'1		deselect
		wait	#8			'8		satisfy Trfc

sdram_init_ret	ret
'
'
' Read/write sdram
'
sdram		mov	outc,h00226000		'1		issue 'auto refresh' command
		setb	outc,#20		'1		deselect, satisfy Trfc in 8 more clocks

		decod3	cmd,cmd		wc	'1		decode size bits, C = write
		and	cmd,#%11111110	wz	'1		isolate bits 7..1

	if_z	jmp	#sdram_ret		'1		if nop, done

		shr	cmd,#1			'1		get loop count

		shl	adr,#7			'1		make 'active' command with bank and row address
		or	adr,#%1_0011_00		'1		(ba[1..0], a[12..0]) = adr[24..10]
		rol	adr,#15			'1

		mov	outc,adr		'1		issue 'active' command
		setb	outc,#20		'1		deselect, satisfy Trcd in 1 more clock

		shr	adr,#22+1		'1		make blank command with bank and column address
		and	outc,h00306000		'1		(ba[1..0], a[12..0]) = (adr[24..23], %0000, adr[9..1])
		or	outc,adr		'1

	if_c	jmp	#:write			'1/4
'
'
' Execute read command				clocks		XFR read SDRAM
'						-------------------------------------------------------------------------------------------------------
		xor	outc,h001A0000		'1					issue 'read' command
		setb	outc,#20		'1					deselect
		wait	#3			'1
		'(wait)				'1					SDRAM sees 'read' command
		'(wait)				'1

:read		wait	#2			'1		input w1 -> AUX[SPB++]
		'(wait)				'1		input w0		SDRAM starts outputting data stream
		setxfr	#%1_110_011		'1		input w1 -> AUX[SPB++]	configure XFR <16_pins_to_AUX>
		wait	#1			'1		input w0		SDRAM data stream begins arriving in XFR
		djnz	cmd,#:read		'1		input w1 -> AUX[SPB++]	loop for each set of 4 longs
		'(djnz if looping, else skip)	'1		input w0
		'(djnz if looping, else skip)	'1		input w1 -> AUX[SPB++]
		'(djnz if looping, else skip)	'1		input w0

		mov	outc,h002C0000		'1		input w0		issue 'burst terminate' command (aligns with XFR cancellation)
		mov	outc,h00240400		'1		input w1 -> AUX[SPB++]	issue 'precharge all' command
		setb	outc,#20		'1		input w0		deselect
		wait	#2			'1		input w1 -> AUX[SPB++]	satisfy Trp
		'(wait)				'1		input w0
		setxfr	#0			'1		input w1 -> AUX[SPB++]	cancel XFR on next clock

		jmp	#sdram_ret

'
'
' Execute write command				clocks		XFR write SDRAM
'						-------------------------------------------------------------------------------------------------------
:write		mov	dirb,hFFFF0000		'1		-			enable data outputs

		setxfr	#%1_010_011		'1		<AUX_to_16_pins>	configure XFR

		xor	outc,h00180000		'1		-			issue 'write' command (aligns with XFR on next clock)
		setb	outc,#20		'1		output AUX[SPB]   w0	deselect

		wait	#1			'1		output AUX[SPB++] w1

:quad		wait	#4			'1		output AUX[SPB]   w0
		'(wait)				'1		output AUX[SPB++] w1
		'(wait)				'1		output AUX[SPB]   w0
		'(wait)				'1		output AUX[SPB++] w1
		djnz	cmd,#:quad		'1		output AUX[SPB]   w0	loop for each quad
		'(djnz if looping, else skip)	'1		output AUX[SPB++] w1
		'(djnz if looping, else skip)	'1		output AUX[SPB]   w0
		'(djnz if looping, else skip)	'1		output AUX[SPB++] w1

		mov	outc,h002C0000		'1		output AUX[SPB++] w1	issue 'burst terminate' command
		mov	dirb,#0		wz	'1		-			cancel data outputs (aligns with 'burst terminate')
		setxfr	#0			'1		-			cancel XFR
		mov	outc,h00240400		'1		-			issue 'precharge all' command
		setb	outc,#20	wz	'1		-			deselect

sdram_ret	ret				'4		-			satisfy Trp, done
'
' Constants
'
h00180000	long	$00180000		'write' command toggle
h001A0000	long	$001A0000		'read' command toggle
h00200037	long	$00200037		'set mode' command (full-page r/w bursts, cas latency = 3)
h00226000	long	$00226000		'read' command mask
h00240400	long	$00240400		'precharge all' command
h002C0000	long	$002C0000		'burst terminate' command
h00306000	long	$00306000		'blank command mask
h003FFFFF	long	$003FFFFF		'control pins mask
hFFFF0000	long	$FFFF0000		'data pins mask
'
'
' Variables
'
cmd		res	1			'command
adr		res	1			'address
